您的位置:首页 > 编程语言 > C语言/C++

leetcode292题 题解 翻译 C语言版 Python版

2016-02-03 16:51 609 查看
292. Nim Game

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

292.Nim游戏(一种博弈游戏)

你和你的朋友在玩下面这个Nim游戏。桌子上有一堆石头,每次你们中的一个人能依次拿走期中1到3个石头。拿走最后一个石头的人就是赢家。你将第一个拿石头。

你们俩都是非常聪明的并且知道这个游戏的最佳策略。写一个函数来确定当给定石头的数量时你能不能赢下这场游戏。

举个例子,如果有4块石头,那么你怎么都赢不了。不管你是拿1块、2块、3块石头,最后一块石头总会被你的朋友拿走。

思路:4块赢不了是因为不管你拿1、2、3,朋友都可以选择一个数来补足成4。所以说题目限制只能拿1、2、3决定了4将是失败量,一旦谁面前有4或者4的倍数,那么他注定赢不了。所以只需要将n模4就行了。n能整除4就先拿先赢,不能整除就后拿后赢。

bool canWinNim(int n) {
return n%4;
}


模运算都可以变成位运算提高速度

bool canWinNim(int n) {
return n&3;
}


python版使用条件表达式,即Python版的三目运算符简化代码

class Solution(object):
def canWinNim(self, n):
"""
:type n: int
:rtype: bool
"""
return True if n%4 else False
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: